<?php

class SinglechoiceController extends Controller
{
	/**
	 * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
	 * using two-column layout. See 'protected/views/layouts/column2.php'.
	 */
	public $layout='common2';
	public $assetsUrl;
	public function init()
	{
		//$this->assetsUrl=$this->module->assetsUrl;
		//不再注册核心脚本，因为要生成两次Yii jquery 文件。
		//Yii::app()->getClientScript()->registerCoreScript('jquery');
	}

	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
			//'accessControl', // perform access control for CRUD operations
			//'postOnly + delete', // we only allow deletion via POST request
		);
	}

	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array(
			array('allow',  // allow all users to perform 'index' and 'view' actions
				'actions'=>array('index','view'),
				'users'=>array('*'),
			),
			array('allow', // allow authenticated user to perform 'create' and 'update' actions
				'actions'=>array('create','update'),
				'users'=>array('@'),
			),
			array('allow', // allow admin user to perform 'admin' and 'delete' actions
				'actions'=>array('admin','delete'),
				'users'=>array('admin'),
			),
			array('deny',  // deny all users
				'users'=>array('*'),
			),
		);
	}

	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{
		$this->render('view',array(
			'model'=>$this->loadModel($id),
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate($charpter_id)
	{	$qq='';$pd=0;
		$model=new Singlechoice;

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['Singlechoice']))
		{
			//判断标题是否重复
			$title=$_POST['Singlechoice']['title'];
			$data_tmp=Singlechoice::model()->findAll("title='$title'");
			if(count($data_tmp)>0)
			{
				header('Content-Type: text/html; charset=utf-8');
				echo "<script>alert('标题已经存在！请修改！');history.back(-1)</script>";
				Yii::app()->end();
			}
			//------------>结束
			foreach($_POST['Singlechoice']['tizhi'] as $value)
			{
				if($pd==0)$qq=$value;
				else
				$qq=$qq.'^-^'.$value;
				$pd=1;
			}
			$_POST['Singlechoice']['tizhi']=$qq;
			$arr=array('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z');
			$_POST['Singlechoice']['answer']=$arr[$_POST['Singlechoice']['answer']];
			
			$model->attributes=$_POST['Singlechoice'];
			if($model->save(false)){
				header('Content-Type: text/html; charset=utf-8');
				echo "<script>alert('添加成功！请继续添加！');history.back(-1)</script>";}
		}
		$criteria=new CDbCriteria(array(
			'order'=>'id asc',
			'select'=>array('id','title'),
		));
		$data=Knowledgelist::model()->findAll($criteria);
		$data=CJSON::decode(CJSON::encode($data));
		
		$criteria_charpter=new CDbCriteria(array(
			'order'=>'id asc',
			'select'=>array('id','level','title'),
		));
		$data_charpter=Category::model()->findAll($criteria_charpter);
		$data_charpter=CJSON::decode(CJSON::encode($data_charpter));
		$arr_charpter=array();
		foreach($data_charpter as $k=>$v){
			$str="";
			//解决目录递进问题
			for($i=1;$i<$v['level'];$i++){
				$str.="─";
			}
			$arr_charpter[$v['id']]=$str.$v['title'];
		}
		//echo "<pre>";
		//print_r($arr_charpter);exit;		
		$newarr=array();
		foreach($data as $k=>$v){
		$id=$v['id'];
			$criteria2=new CDbCriteria(array(
				'order'=>'id asc',
				'select'=>array('id','title'),
				'condition'=>"Knowledgelist_id='$id'",
			));
			$data2=Knowledgepoint::model()->findAll($criteria2);
			$data2=CJSON::decode(CJSON::encode($data2));
			//$newarr[$v['title']]=$data2;
			foreach($data2 as $k=>$v2){
				$newarr[$v['title']][$v2['id']]=$v2['title'];
			}
			//$newarr['title'][]=$data2;
		}
		$model->charpter_id=$charpter_id;
		$this->render('create',array(
			'model'=>$model,
			'data'=>$newarr,
			'data2'=>$arr_charpter,
		));
	}

	/**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be updated
	 */
	public function actionUpdate($id)
	{$qq='';$pd=0;
		$model=$this->loadModel($id);
		
		if(isset($_POST['Singlechoice']))
		{
			//判断标题是否重复
			$title=$_POST['Singlechoice']['title'];
			$data_tmp=Singlechoice::model()->findAll("title='$title' and id<>'$id'");
			if(count($data_tmp)>0)
			{
				header('Content-Type: text/html; charset=utf-8');
				echo "<script>alert('标题已经存在！请修改！');history.back(-1)</script>";
				Yii::app()->end();
				
			}
			//判断结束
			foreach($_POST['Singlechoice']['tizhi'] as $value)
			{
				if($pd==0)$qq=$value;
				else
				$qq=$qq.'^-^'.$value;
				$pd=1;
			}
			$_POST['Singlechoice']['tizhi']=$qq;
			$arr=array('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z');
			$_POST['Singlechoice']['answer']=$arr[$_POST['Singlechoice']['answer']];
			$model->attributes=$_POST['Singlechoice'];
			if($model->save(false)){
				header('Content-Type: text/html; charset=utf-8');
				echo "<script>alert('更新成功！请关闭此窗口！');</script>";}
		}
	
		
		$criteria=new CDbCriteria(array(
			'order'=>'id asc',
			'select'=>array('id','title'),
		));
		$data=Knowledgelist::model()->findAll($criteria);
		$data=CJSON::decode(CJSON::encode($data));
		
		$criteria_charpter=new CDbCriteria(array(
			'order'=>'id asc',
			'select'=>array('id','level','title'),
		));
		$data_charpter=Category::model()->findAll($criteria_charpter);
		$data_charpter=CJSON::decode(CJSON::encode($data_charpter));
		$arr_charpter=array();
		foreach($data_charpter as $k=>$v){
			$str="";
			//解决目录递进问题
			for($i=1;$i<$v['level'];$i++){
				$str.="─";
			}
			$arr_charpter[$v['id']]=$str.$v['title'];
		}
		//echo "<pre>";
		//print_r($arr_charpter);exit;		
		$newarr=array();
		foreach($data as $k=>$v){
		$id=$v['id'];
			$criteria2=new CDbCriteria(array(
				'order'=>'id asc',
				'select'=>array('id','title'),
				'condition'=>"Knowledgelist_id='$id'",
			));
			$data2=Knowledgepoint::model()->findAll($criteria2);
			$data2=CJSON::decode(CJSON::encode($data2));
			//$newarr[$v['title']]=$data2;
			foreach($data2 as $k=>$v2){
				$newarr[$v['title']][$v2['id']]=$v2['title'];
			}
			//$newarr['title'][]=$data2;
		}
		//$model->charpter_id=$id;
		$this->render('update',array(
			'model'=>$model,
			'data'=>$newarr,
			'data2'=>$arr_charpter,
		));
		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);


	}

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionDelete($id)
	{
		$this->loadModel($id)->delete();

		// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
		if(!isset($_GET['ajax']))
			$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
	}

	/**
	 * Lists all models.
	 */
	public function actionIndex()
	{
		$dataProvider=new CActiveDataProvider('Singlechoice');
		$this->render('index',array(
			'dataProvider'=>$dataProvider,
		));
	}

	/**
	 * Manages all models.
	 */
	public function actionAdmin()
	{
		$model=new Singlechoice('search');
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['Singlechoice']))
			$model->attributes=$_GET['Singlechoice'];

		$this->render('admin',array(
			'model'=>$model,
		));
	}

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer the ID of the model to be loaded
	 */
	public function loadModel($id)
	{
		$model=Singlechoice::model()->findByPk($id);
		if($model===null)
			throw new CHttpException(404,'The requested page does not exist.');
		return $model;
	}

	/**
	 * Performs the AJAX validation.
	 * @param CModel the model to be validated
	 */
	protected function performAjaxValidation($model)
	{
		if(isset($_POST['ajax']) && $_POST['ajax']==='singlechoice-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}
	}
	public function actionList($charpter_id){
		$this->render('admin',array(
			'charpter_id'=>$charpter_id,
		));
	}
	//取所有数据
	public function actionQq($charpter_id){
		$order=Yii::app()->request->getPost('order');
		$sort=Yii::app()->request->getPost('sort');
		$page=Yii::app()->request->getPost('page');
		$rows=Yii::app()->request->getPost('rows');
		
		$title=Yii::app()->request->getPost('title');//查询标题
		$condition_1="charpter_id='$charpter_id'";
		$condition_2="charpter_id='$charpter_id' and t.title='$title'";
		$condition=(isset($title))?$condition_2:$condition_1;
		
		$model=new Singlechoice;
		$criteria=new CDbCriteria(array(
			'order'=>"t.$sort $order",
			//'select'=>array('id','title'),//'id,title',
			//'select'=>'knowledgepoint.title,t.id,t.title',
			'condition'=>$condition,
			'limit'=>$rows,
			'offset'=>($page-1)*$rows,
			'with'=>'singletest',
		));

		$count = $model->count($criteria);
		$data3=$model->findAll($criteria);
		$json = new CArJSON();
		// Define which relations do you want to load
		$relations = array('singletest');
		// Define which attributes, foreach relations do you want to load
		// root denote attributes for the main model
		$attributes = array(
			'root' => array('id', 'title','created','modified','frequency','difficulty','forbidden'),//表示主表中的字段
			'singletest' => array( 'title' ),//表示从表中的字段
			//'votes' => null, // This will load all attributes
		);
		$data=$json->toJSON($data3, $relations, $attributes);
		//print_r(CJSON::decode($data));
		$i=0;$newarr=array();
		foreach(CJSON::decode($data) as $key=>$value)
		{
			//echo $key;echo $value['attributes']['id'];
			$newarr[$i]['id']=$value['attributes']['id'];
			$newarr[$i]['title']=$value['attributes']['title'];
			$newarr[$i]['created']=$value['attributes']['created'];
			$newarr[$i]['modified']=$value['attributes']['modified'];
			$newarr[$i]['frequency']=$value['attributes']['frequency'];
			$newarr[$i]['forbidden']=($value['attributes']['forbidden'])?'Yes':'No';
			$newarr[$i]['difficulty']=$value['attributes']['difficulty'];
			$newarr[$i]['knowledgepoint_id']=$value['relations']['singletest']['title'];$i++;
		}

			$data2=CJSON::encode($newarr);
			$data='{'.'"total":'.$count.','.'"rows":'.$data2.'}';
			echo $data;	
	}
	//>---------------------单行删除
	public function actionDeleterow(){
		$id=Yii::app()->request->getPost('id');
		if($this->loadModel($id)->delete()){
			echo "yes";
		}
	}
	//>---------------多行删除
	public function actionDeleteall(){
		$arr=(array)(CJSON::decode(Yii::app()->request->getPost('qq')));
		foreach($arr as $value){
			$newarr[]=(array)$value;
		}
		$str='';
		//print_r($newarr);
		foreach($newarr as $value){
			$title=trim($value['title']);
			$id=trim($value['id']);
				if($this->loadModel($id)->delete()){
					$str.='删除单选题《'.$title.'》成功！<br/>';
				}else
				{
					$str.='删除单选题《'.$title.'》失败！<br/>';
				}            
		}
		echo $str;
	}
	//->------------------禁用或启用
	public function actionOnoff($charpter_id=null){
		$model=new Singlechoice;
		$arr=(array)(CJSON::decode(Yii::app()->request->getPost('qq')));
		$onoff=Yii::app()->request->getPost('action');
		//print_r($arr);exit;
		if(!empty($arr)){
			foreach($arr as $value){
				$arr_in[]=$value['id'];
			}
		$criteria = new CDbCriteria;
		$criteria->addInCondition('id',$arr_in);			
		}
		//print_r($newarr);exit;
		$criteria2=new CDbCriteria(array(
			'condition'=>"charpter_id='$charpter_id'",
		));
		if($onoff=="addon"){
			$data=$model->updateAll(array('forbidden'=>false),$criteria);
			if($data) echo "启用成功！";else echo "启用失败！";
		}
		if($onoff=="addoff"){
			$data=$model->updateAll(array('forbidden'=>true),$criteria);
			if($data) echo "禁用成功！";else echo "禁用失败！";
		}
		if($onoff=="alladdon"){
			$data=$model->updateAll(array('forbidden'=>false),$criteria2);
			if($data) echo "全体启用成功！";else echo "全体启用失败！";
		}
		if($onoff=="alladdoff"){
			$data=$model->updateAll(array('forbidden'=>true),$criteria2);
			if($data) echo "全体禁用成功！";else echo "全体禁用失败！";
		}
	}
	public function actionClear_zero($charpter_id=null)
	{
		$model=new Singlechoice;
		$pinlv_nandu=Yii::app()->request->getPost('action');
		$criteria=new CDbCriteria(array(
			'condition'=>"charpter_id='$charpter_id'",
		));
		if($pinlv_nandu=="pinlv"){
			$data=$model->updateAll(array('frequency'=>0),$criteria);
			if($data) echo "全体频率清零成功！";else echo "全体频率清零失败！";
		}
		if($pinlv_nandu=="nandu"){
			$data=$model->updateAll(array('difficulty'=>0),$criteria);
			if($data) echo "全体难度清零成功！";else echo "全体难度清零失败！";
		}	
	}
}
